# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Chassis100Chassis(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Chassis100Chassis - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'odata_context': 'Odata400Context',
            'odata_id': 'Odata400Id',
            'odata_type': 'Odata400Type',
            'actions': 'Chassis100ChassisActions',
            'chassis_type': 'Chassis100ChassisType',
            'description': 'ResourceDescription',
            'id': 'ResourceId',
            'indicator_led': 'Chassis100IndicatorLED',
            'links': 'Chassis100ChassisLinks',
            'log_services': 'LogServiceCollectionLogServiceCollection',
            'name': 'ResourceName',
            'oem': 'ResourceOem',
            'power': 'PowerPower',
            'status': 'ResourceStatus',
            'thermal': 'ThermalThermal'
        }

        self.attribute_map = {
            'odata_context': '@odata.context',
            'odata_id': '@odata.id',
            'odata_type': '@odata.type',
            'actions': 'Actions',
            'chassis_type': 'ChassisType',
            'description': 'Description',
            'id': 'Id',
            'indicator_led': 'IndicatorLED',
            'links': 'Links',
            'log_services': 'LogServices',
            'name': 'Name',
            'oem': 'Oem',
            'power': 'Power',
            'status': 'Status',
            'thermal': 'Thermal'
        }

        self._odata_context = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._chassis_type = None
        self._description = None
        self._id = None
        self._indicator_led = None
        self._links = None
        self._log_services = None
        self._name = None
        self._oem = None
        self._power = None
        self._status = None
        self._thermal = None

    @property
    def odata_context(self):
        """
        Gets the odata_context of this Chassis100Chassis.


        :return: The odata_context of this Chassis100Chassis.
        :rtype: Odata400Context
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """
        Sets the odata_context of this Chassis100Chassis.


        :param odata_context: The odata_context of this Chassis100Chassis.
        :type: Odata400Context
        """
        self._odata_context = odata_context

    @property
    def odata_id(self):
        """
        Gets the odata_id of this Chassis100Chassis.


        :return: The odata_id of this Chassis100Chassis.
        :rtype: Odata400Id
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """
        Sets the odata_id of this Chassis100Chassis.


        :param odata_id: The odata_id of this Chassis100Chassis.
        :type: Odata400Id
        """
        self._odata_id = odata_id

    @property
    def odata_type(self):
        """
        Gets the odata_type of this Chassis100Chassis.


        :return: The odata_type of this Chassis100Chassis.
        :rtype: Odata400Type
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """
        Sets the odata_type of this Chassis100Chassis.


        :param odata_type: The odata_type of this Chassis100Chassis.
        :type: Odata400Type
        """
        self._odata_type = odata_type

    @property
    def actions(self):
        """
        Gets the actions of this Chassis100Chassis.


        :return: The actions of this Chassis100Chassis.
        :rtype: Chassis100ChassisActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """
        Sets the actions of this Chassis100Chassis.


        :param actions: The actions of this Chassis100Chassis.
        :type: Chassis100ChassisActions
        """
        self._actions = actions

    @property
    def chassis_type(self):
        """
        Gets the chassis_type of this Chassis100Chassis.
        This property indicates the type of physical form factor of this resource.

        :return: The chassis_type of this Chassis100Chassis.
        :rtype: Chassis100ChassisType
        """
        return self._chassis_type

    @chassis_type.setter
    def chassis_type(self, chassis_type):
        """
        Sets the chassis_type of this Chassis100Chassis.
        This property indicates the type of physical form factor of this resource.

        :param chassis_type: The chassis_type of this Chassis100Chassis.
        :type: Chassis100ChassisType
        """
        self._chassis_type = chassis_type

    @property
    def description(self):
        """
        Gets the description of this Chassis100Chassis.


        :return: The description of this Chassis100Chassis.
        :rtype: ResourceDescription
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this Chassis100Chassis.


        :param description: The description of this Chassis100Chassis.
        :type: ResourceDescription
        """
        self._description = description

    @property
    def id(self):
        """
        Gets the id of this Chassis100Chassis.


        :return: The id of this Chassis100Chassis.
        :rtype: ResourceId
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Chassis100Chassis.


        :param id: The id of this Chassis100Chassis.
        :type: ResourceId
        """
        self._id = id

    @property
    def indicator_led(self):
        """
        Gets the indicator_led of this Chassis100Chassis.
        The state of the indicator LED, used to identify the chassis.

        :return: The indicator_led of this Chassis100Chassis.
        :rtype: Chassis100IndicatorLED
        """
        return self._indicator_led

    @indicator_led.setter
    def indicator_led(self, indicator_led):
        """
        Sets the indicator_led of this Chassis100Chassis.
        The state of the indicator LED, used to identify the chassis.

        :param indicator_led: The indicator_led of this Chassis100Chassis.
        :type: Chassis100IndicatorLED
        """
        self._indicator_led = indicator_led

    @property
    def links(self):
        """
        Gets the links of this Chassis100Chassis.


        :return: The links of this Chassis100Chassis.
        :rtype: Chassis100ChassisLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """
        Sets the links of this Chassis100Chassis.


        :param links: The links of this Chassis100Chassis.
        :type: Chassis100ChassisLinks
        """
        self._links = links

    @property
    def log_services(self):
        """
        Gets the log_services of this Chassis100Chassis.
        A reference to the logs for this chassis.

        :return: The log_services of this Chassis100Chassis.
        :rtype: LogServiceCollectionLogServiceCollection
        """
        return self._log_services

    @log_services.setter
    def log_services(self, log_services):
        """
        Sets the log_services of this Chassis100Chassis.
        A reference to the logs for this chassis.

        :param log_services: The log_services of this Chassis100Chassis.
        :type: LogServiceCollectionLogServiceCollection
        """
        self._log_services = log_services

    @property
    def name(self):
        """
        Gets the name of this Chassis100Chassis.


        :return: The name of this Chassis100Chassis.
        :rtype: ResourceName
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Chassis100Chassis.


        :param name: The name of this Chassis100Chassis.
        :type: ResourceName
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this Chassis100Chassis.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this Chassis100Chassis.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this Chassis100Chassis.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this Chassis100Chassis.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def power(self):
        """
        Gets the power of this Chassis100Chassis.
        A reference to the power properties (power supplies, power policies, sensors) for this chassis.

        :return: The power of this Chassis100Chassis.
        :rtype: PowerPower
        """
        return self._power

    @power.setter
    def power(self, power):
        """
        Sets the power of this Chassis100Chassis.
        A reference to the power properties (power supplies, power policies, sensors) for this chassis.

        :param power: The power of this Chassis100Chassis.
        :type: PowerPower
        """
        self._power = power

    @property
    def status(self):
        """
        Gets the status of this Chassis100Chassis.


        :return: The status of this Chassis100Chassis.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this Chassis100Chassis.


        :param status: The status of this Chassis100Chassis.
        :type: ResourceStatus
        """
        self._status = status

    @property
    def thermal(self):
        """
        Gets the thermal of this Chassis100Chassis.
        A reference to the thermal properties (fans, cooling, sensors) for this chassis.

        :return: The thermal of this Chassis100Chassis.
        :rtype: ThermalThermal
        """
        return self._thermal

    @thermal.setter
    def thermal(self, thermal):
        """
        Sets the thermal of this Chassis100Chassis.
        A reference to the thermal properties (fans, cooling, sensors) for this chassis.

        :param thermal: The thermal of this Chassis100Chassis.
        :type: ThermalThermal
        """
        self._thermal = thermal

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

