# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Power100PowerSupply(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Power100PowerSupply - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'line_input_voltage_type': 'Power100LineInputVoltageType',
            'member_id': 'str',
            'oem': 'ResourceOem',
            'power_supply_type': 'Power100PowerSupplyType',
            'redundancy': 'list[RedundancyRedundancy]',
            'redundancyodata_count': 'Odata400Count',
            'redundancyodata_navigation_link': 'Odata400IdRef',
            'related_item': 'list[Odata400IdRef]',
            'related_itemodata_count': 'Odata400Count',
            'related_itemodata_navigation_link': 'Odata400IdRef',
            'status': 'ResourceStatus'
        }

        self.attribute_map = {
            'line_input_voltage_type': 'LineInputVoltageType',
            'member_id': 'MemberId',
            'oem': 'Oem',
            'power_supply_type': 'PowerSupplyType',
            'redundancy': 'Redundancy',
            'redundancyodata_count': 'Redundancy@odata.count',
            'redundancyodata_navigation_link': 'Redundancy@odata.navigationLink',
            'related_item': 'RelatedItem',
            'related_itemodata_count': 'RelatedItem@odata.count',
            'related_itemodata_navigation_link': 'RelatedItem@odata.navigationLink',
            'status': 'Status'
        }

        self._line_input_voltage_type = None
        self._member_id = None
        self._oem = None
        self._power_supply_type = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._redundancyodata_navigation_link = None
        self._related_item = None
        self._related_itemodata_count = None
        self._related_itemodata_navigation_link = None
        self._status = None

    @property
    def line_input_voltage_type(self):
        """
        Gets the line_input_voltage_type of this Power100PowerSupply.
        The line voltage type supported as an input to this Power Supply

        :return: The line_input_voltage_type of this Power100PowerSupply.
        :rtype: Power100LineInputVoltageType
        """
        return self._line_input_voltage_type

    @line_input_voltage_type.setter
    def line_input_voltage_type(self, line_input_voltage_type):
        """
        Sets the line_input_voltage_type of this Power100PowerSupply.
        The line voltage type supported as an input to this Power Supply

        :param line_input_voltage_type: The line_input_voltage_type of this Power100PowerSupply.
        :type: Power100LineInputVoltageType
        """
        self._line_input_voltage_type = line_input_voltage_type

    @property
    def member_id(self):
        """
        Gets the member_id of this Power100PowerSupply.
        This is the identifier for the member within the collection.

        :return: The member_id of this Power100PowerSupply.
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """
        Sets the member_id of this Power100PowerSupply.
        This is the identifier for the member within the collection.

        :param member_id: The member_id of this Power100PowerSupply.
        :type: str
        """
        self._member_id = member_id

    @property
    def oem(self):
        """
        Gets the oem of this Power100PowerSupply.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this Power100PowerSupply.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this Power100PowerSupply.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this Power100PowerSupply.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def power_supply_type(self):
        """
        Gets the power_supply_type of this Power100PowerSupply.
        The Power Supply type (AC or DC)

        :return: The power_supply_type of this Power100PowerSupply.
        :rtype: Power100PowerSupplyType
        """
        return self._power_supply_type

    @power_supply_type.setter
    def power_supply_type(self, power_supply_type):
        """
        Sets the power_supply_type of this Power100PowerSupply.
        The Power Supply type (AC or DC)

        :param power_supply_type: The power_supply_type of this Power100PowerSupply.
        :type: Power100PowerSupplyType
        """
        self._power_supply_type = power_supply_type

    @property
    def redundancy(self):
        """
        Gets the redundancy of this Power100PowerSupply.
        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.

        :return: The redundancy of this Power100PowerSupply.
        :rtype: list[RedundancyRedundancy]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """
        Sets the redundancy of this Power100PowerSupply.
        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.

        :param redundancy: The redundancy of this Power100PowerSupply.
        :type: list[RedundancyRedundancy]
        """
        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """
        Gets the redundancyodata_count of this Power100PowerSupply.


        :return: The redundancyodata_count of this Power100PowerSupply.
        :rtype: Odata400Count
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """
        Sets the redundancyodata_count of this Power100PowerSupply.


        :param redundancyodata_count: The redundancyodata_count of this Power100PowerSupply.
        :type: Odata400Count
        """
        self._redundancyodata_count = redundancyodata_count

    @property
    def redundancyodata_navigation_link(self):
        """
        Gets the redundancyodata_navigation_link of this Power100PowerSupply.


        :return: The redundancyodata_navigation_link of this Power100PowerSupply.
        :rtype: Odata400IdRef
        """
        return self._redundancyodata_navigation_link

    @redundancyodata_navigation_link.setter
    def redundancyodata_navigation_link(self, redundancyodata_navigation_link):
        """
        Sets the redundancyodata_navigation_link of this Power100PowerSupply.


        :param redundancyodata_navigation_link: The redundancyodata_navigation_link of this Power100PowerSupply.
        :type: Odata400IdRef
        """
        self._redundancyodata_navigation_link = redundancyodata_navigation_link

    @property
    def related_item(self):
        """
        Gets the related_item of this Power100PowerSupply.
        The ID(s) of the resources associated with this Power Limit

        :return: The related_item of this Power100PowerSupply.
        :rtype: list[Odata400IdRef]
        """
        return self._related_item

    @related_item.setter
    def related_item(self, related_item):
        """
        Sets the related_item of this Power100PowerSupply.
        The ID(s) of the resources associated with this Power Limit

        :param related_item: The related_item of this Power100PowerSupply.
        :type: list[Odata400IdRef]
        """
        self._related_item = related_item

    @property
    def related_itemodata_count(self):
        """
        Gets the related_itemodata_count of this Power100PowerSupply.


        :return: The related_itemodata_count of this Power100PowerSupply.
        :rtype: Odata400Count
        """
        return self._related_itemodata_count

    @related_itemodata_count.setter
    def related_itemodata_count(self, related_itemodata_count):
        """
        Sets the related_itemodata_count of this Power100PowerSupply.


        :param related_itemodata_count: The related_itemodata_count of this Power100PowerSupply.
        :type: Odata400Count
        """
        self._related_itemodata_count = related_itemodata_count

    @property
    def related_itemodata_navigation_link(self):
        """
        Gets the related_itemodata_navigation_link of this Power100PowerSupply.


        :return: The related_itemodata_navigation_link of this Power100PowerSupply.
        :rtype: Odata400IdRef
        """
        return self._related_itemodata_navigation_link

    @related_itemodata_navigation_link.setter
    def related_itemodata_navigation_link(self, related_itemodata_navigation_link):
        """
        Sets the related_itemodata_navigation_link of this Power100PowerSupply.


        :param related_itemodata_navigation_link: The related_itemodata_navigation_link of this Power100PowerSupply.
        :type: Odata400IdRef
        """
        self._related_itemodata_navigation_link = related_itemodata_navigation_link

    @property
    def status(self):
        """
        Gets the status of this Power100PowerSupply.


        :return: The status of this Power100PowerSupply.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this Power100PowerSupply.


        :param status: The status of this Power100PowerSupply.
        :type: ResourceStatus
        """
        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

